import _e, { useContext as Rt, Children as wt, useMemo as Z, useRef as ae, useLayoutEffect as Ct, forwardRef as mt, useEffect as yt, useCallback as xe, useState as Je, createElement as bt } from "react";
const K = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var L = /* @__PURE__ */ ((a) => (a.Id = "__id__", a.Value = "__value__", a))(L || {});
const Fe = "mk-input";
class Ot {
  constructor(t, r) {
    this.raw = t, this.uniRegExp = r, this.done = !1;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let t = this.uniRegExp.exec(this.raw);
    if (t === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [r, n, i] = this.extractSlices(t);
    return this.raw = i, { done: !1, value: [r, n] };
  }
  extractSlices(t) {
    const r = this.extractMark(t), n = r.input.substring(0, r.index), i = r.input.substring(r.index + r.annotation.length);
    return [n, r, i];
  }
  extractMark(t) {
    let r = t[0], n = 0, i = t[1], c = t[2];
    for (; !(i || c); )
      n++, i = t[2 * n + 1], c = t[2 * n + 2];
    let v = t.index, u = t.input;
    return { annotation: r, value: i, id: c, input: u, index: v, childIndex: n };
  }
}
class oe {
  get regExps() {
    return this.markups.map(Tt);
  }
  static split(t, r) {
    const n = r.map((i) => i.markup);
    return () => new oe(n).split(t);
  }
  constructor(t) {
    this.markups = t, this.uniRegExp = new RegExp(this.regExps.map((r) => r.source).join("|"));
  }
  split(t) {
    return this.iterateMatches(t);
  }
  iterateMatches(t) {
    const r = [];
    for (let [n, i] of new Ot(t, this.uniRegExp))
      r.push(n), i !== null && r.push(kt(i, this.markups[i.childIndex]));
    return r;
  }
}
const Pt = Object.assign, Tt = (a) => {
  const t = X(a), r = a[a.indexOf(L.Value) + L.Value.length], n = a[a.indexOf(L.Id) + L.Id.length];
  return new RegExp(
    t.replace(L.Value, `([^${X(r || "")}]+?)`).replace(L.Id, `([^${X(n || "")}]+?)`)
  );
}, St = (a) => {
  const r = X(a) + "(\\w*)";
  return new RegExp(r);
};
function Re(a, t, r) {
  let n = a.replace(L.Value, t);
  return r ? n.replace(L.Id, r) : n;
}
function Qt(a, t, ...r) {
  return new oe(r).split(a).reduce((i, c) => i += ie(c) ? t(c) : c, "");
}
const X = (a) => a.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function Ke(a, t) {
  let r = "";
  for (let n of a)
    r += ie(n) ? Re(t[n.childIndex].markup, n.value, n.id) : n;
  return r;
}
const kt = (a, t) => a.annotation !== Re(t, a.value, a.id) ? { ...a, id: a.value, value: a.id } : a, ne = (a, t = 0) => {
  let r = 3735928559 ^ t, n = 1103547991 ^ t;
  for (let i = 0, c; i < a.length; i++)
    c = a.charCodeAt(i), r = Math.imul(r ^ c, 2654435761), n = Math.imul(n ^ c, 1597334677);
  return r = Math.imul(r ^ r >>> 16, 2246822507) ^ Math.imul(n ^ n >>> 13, 3266489909), n = Math.imul(n ^ n >>> 16, 2246822507) ^ Math.imul(r ^ r >>> 13, 3266489909), 4294967296 * (2097151 & n) + (r >>> 0);
}, ie = (a) => typeof a == "object";
function jt(a) {
  return wt.map(a, (t) => t.props);
}
const At = (a) => {
  const t = _e.createContext(void 0);
  t.displayName = a;
  const r = i(t), n = c(t);
  return [r, n];
  function i(v) {
    return () => {
      const u = Rt(v);
      if (u)
        return u;
      throw new Error(`The context ${v.displayName} didn't found!`);
    };
  }
  function c(v) {
    return v.Provider;
  }
}, [se, Dt] = At("MarkedInputStoreProvider"), Nt = () => Z(() => new G(), []);
class G {
  constructor(t = NaN) {
    this._position = t;
  }
  get isBlurred() {
    return Number.isNaN(this._position);
  }
  clear() {
    this._position = NaN;
  }
  static setIndex(t, r) {
    const n = window.getSelection();
    if (!(n != null && n.anchorNode) || !n.rangeCount)
      return;
    const i = n.getRangeAt(0);
    i == null || i.setStart(t.firstChild || t, r), i == null || i.setEnd(t.firstChild || t, r);
  }
  static getCaretIndex(t) {
    let r = 0;
    const n = window.getSelection();
    if (!(n != null && n.rangeCount))
      return r;
    const i = n.getRangeAt(0), c = i.cloneRange();
    return c.selectNodeContents(t), c.setEnd(i.endContainer, i.endOffset), r = c.toString().length, r;
  }
  getPosition() {
    let t = this._position;
    return this._position = NaN, t;
  }
  setPosition(t) {
    this._position = t;
  }
  static setCaretToEnd(t) {
    const r = window.getSelection();
    r == null || r.setPosition(t, 1);
  }
  static getIndex() {
    var r;
    const t = window.getSelection();
    return (r = t == null ? void 0 : t.anchorOffset) != null ? r : NaN;
  }
  saveRightOffset() {
    var n, i;
    const t = window.getSelection(), r = (i = (n = t == null ? void 0 : t.anchorNode) == null ? void 0 : n.textContent) == null ? void 0 : i.length;
    this._position = r != null ? r : NaN;
  }
  restoreRightOffset() {
    var c, v;
    if (this.isBlurred)
      return;
    const t = window.getSelection(), r = t != null && t.rangeCount ? t.getRangeAt(0) : null;
    if (!(t != null && t.anchorNode))
      return;
    let n = (t == null ? void 0 : t.anchorNode.firstChild) || (t == null ? void 0 : t.anchorNode), i = ((v = (c = n == null ? void 0 : n.textContent) == null ? void 0 : c.length) != null ? v : 0) - this._position;
    r == null || r.setStart(n, i), r == null || r.setEnd(n, i), this.clear();
  }
  static setIndex1(t) {
    const r = window.getSelection();
    if (!(r != null && r.anchorNode) || !r.rangeCount)
      return;
    const n = r.getRangeAt(0);
    n == null || n.setStart(n.startContainer.firstChild || n.startContainer, t), n == null || n.setEnd(n.startContainer.firstChild || n.startContainer, t);
  }
  setCaretRightTo(t, r) {
    const n = window.getSelection(), i = n == null ? void 0 : n.getRangeAt(0);
    i == null || i.setStart(i.endContainer, r), i == null || i.setEnd(i.endContainer, r);
  }
}
const It = (a) => {
  const t = ae(NaN);
  function r() {
    !a.current || (t.current = G.getCaretIndex(a.current));
  }
  function n() {
    !a.current || (G.setIndex(a.current, t.current), t.current = NaN);
  }
  return Ct(() => {
    Number.isNaN(t.current) || n();
  }), r;
};
var Y = /* @__PURE__ */ ((a) => (a[a.Change = 0] = "Change", a[a.Delete = 1] = "Delete", a))(Y || {}), we = { exports: {} }, q = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var he, qe;
function ze() {
  if (qe)
    return he;
  qe = 1;
  var a = Object.getOwnPropertySymbols, t = Object.prototype.hasOwnProperty, r = Object.prototype.propertyIsEnumerable;
  function n(c) {
    if (c == null)
      throw new TypeError("Object.assign cannot be called with null or undefined");
    return Object(c);
  }
  function i() {
    try {
      if (!Object.assign)
        return !1;
      var c = new String("abc");
      if (c[5] = "de", Object.getOwnPropertyNames(c)[0] === "5")
        return !1;
      for (var v = {}, u = 0; u < 10; u++)
        v["_" + String.fromCharCode(u)] = u;
      var d = Object.getOwnPropertyNames(v).map(function(l) {
        return v[l];
      });
      if (d.join("") !== "0123456789")
        return !1;
      var p = {};
      return "abcdefghijklmnopqrst".split("").forEach(function(l) {
        p[l] = l;
      }), Object.keys(Object.assign({}, p)).join("") === "abcdefghijklmnopqrst";
    } catch {
      return !1;
    }
  }
  return he = i() ? Object.assign : function(c, v) {
    for (var u, d = n(c), p, l = 1; l < arguments.length; l++) {
      u = Object(arguments[l]);
      for (var R in u)
        t.call(u, R) && (d[R] = u[R]);
      if (a) {
        p = a(u);
        for (var h = 0; h < p.length; h++)
          r.call(u, p[h]) && (d[p[h]] = u[p[h]]);
      }
    }
    return d;
  }, he;
}
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Ge;
function Mt() {
  if (Ge)
    return q;
  Ge = 1, ze();
  var a = _e, t = 60103;
  if (q.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
    var r = Symbol.for;
    t = r("react.element"), q.Fragment = r("react.fragment");
  }
  var n = a.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, i = Object.prototype.hasOwnProperty, c = { key: !0, ref: !0, __self: !0, __source: !0 };
  function v(u, d, p) {
    var l, R = {}, h = null, _ = null;
    p !== void 0 && (h = "" + p), d.key !== void 0 && (h = "" + d.key), d.ref !== void 0 && (_ = d.ref);
    for (l in d)
      i.call(d, l) && !c.hasOwnProperty(l) && (R[l] = d[l]);
    if (u && u.defaultProps)
      for (l in d = u.defaultProps, d)
        R[l] === void 0 && (R[l] = d[l]);
    return { $$typeof: t, type: u, key: h, ref: _, props: R, _owner: n.current };
  }
  return q.jsx = v, q.jsxs = v, q;
}
var Ee = {};
/** @license React v17.0.2
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var He;
function Vt() {
  return He || (He = 1, function(a) {
    process.env.NODE_ENV !== "production" && function() {
      var t = _e, r = ze(), n = 60103, i = 60106;
      a.Fragment = 60107;
      var c = 60108, v = 60114, u = 60109, d = 60110, p = 60112, l = 60113, R = 60120, h = 60115, _ = 60116, m = 60121, A = 60122, O = 60117, D = 60129, P = 60131;
      if (typeof Symbol == "function" && Symbol.for) {
        var E = Symbol.for;
        n = E("react.element"), i = E("react.portal"), a.Fragment = E("react.fragment"), c = E("react.strict_mode"), v = E("react.profiler"), u = E("react.provider"), d = E("react.context"), p = E("react.forward_ref"), l = E("react.suspense"), R = E("react.suspense_list"), h = E("react.memo"), _ = E("react.lazy"), m = E("react.block"), A = E("react.server.block"), O = E("react.fundamental"), E("react.scope"), E("react.opaque.id"), D = E("react.debug_trace_mode"), E("react.offscreen"), P = E("react.legacy_hidden");
      }
      var S = typeof Symbol == "function" && Symbol.iterator, j = "@@iterator";
      function B(e) {
        if (e === null || typeof e != "object")
          return null;
        var o = S && e[S] || e[j];
        return typeof o == "function" ? o : null;
      }
      var M = t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
      function T(e) {
        {
          for (var o = arguments.length, s = new Array(o > 1 ? o - 1 : 0), f = 1; f < o; f++)
            s[f - 1] = arguments[f];
          N("error", e, s);
        }
      }
      function N(e, o, s) {
        {
          var f = M.ReactDebugCurrentFrame, w = f.getStackAddendum();
          w !== "" && (o += "%s", s = s.concat([w]));
          var C = s.map(function(x) {
            return "" + x;
          });
          C.unshift("Warning: " + o), Function.prototype.apply.call(console[e], console, C);
        }
      }
      var H = !1;
      function Xe(e) {
        return !!(typeof e == "string" || typeof e == "function" || e === a.Fragment || e === v || e === D || e === c || e === l || e === R || e === P || H || typeof e == "object" && e !== null && (e.$$typeof === _ || e.$$typeof === h || e.$$typeof === u || e.$$typeof === d || e.$$typeof === p || e.$$typeof === O || e.$$typeof === m || e[0] === A));
      }
      function Ze(e, o, s) {
        var f = o.displayName || o.name || "";
        return e.displayName || (f !== "" ? s + "(" + f + ")" : s);
      }
      function Ce(e) {
        return e.displayName || "Context";
      }
      function I(e) {
        if (e == null)
          return null;
        if (typeof e.tag == "number" && T("Received an unexpected object in getComponentName(). This is likely a bug in React. Please file an issue."), typeof e == "function")
          return e.displayName || e.name || null;
        if (typeof e == "string")
          return e;
        switch (e) {
          case a.Fragment:
            return "Fragment";
          case i:
            return "Portal";
          case v:
            return "Profiler";
          case c:
            return "StrictMode";
          case l:
            return "Suspense";
          case R:
            return "SuspenseList";
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case d:
              var o = e;
              return Ce(o) + ".Consumer";
            case u:
              var s = e;
              return Ce(s._context) + ".Provider";
            case p:
              return Ze(e, e.render, "ForwardRef");
            case h:
              return I(e.type);
            case m:
              return I(e._render);
            case _: {
              var f = e, w = f._payload, C = f._init;
              try {
                return I(C(w));
              } catch {
                return null;
              }
            }
          }
        return null;
      }
      var J = 0, me, ye, be, Oe, Pe, Te, Se;
      function ke() {
      }
      ke.__reactDisabledLog = !0;
      function Qe() {
        {
          if (J === 0) {
            me = console.log, ye = console.info, be = console.warn, Oe = console.error, Pe = console.group, Te = console.groupCollapsed, Se = console.groupEnd;
            var e = {
              configurable: !0,
              enumerable: !0,
              value: ke,
              writable: !0
            };
            Object.defineProperties(console, {
              info: e,
              log: e,
              warn: e,
              error: e,
              group: e,
              groupCollapsed: e,
              groupEnd: e
            });
          }
          J++;
        }
      }
      function et() {
        {
          if (J--, J === 0) {
            var e = {
              configurable: !0,
              enumerable: !0,
              writable: !0
            };
            Object.defineProperties(console, {
              log: r({}, e, {
                value: me
              }),
              info: r({}, e, {
                value: ye
              }),
              warn: r({}, e, {
                value: be
              }),
              error: r({}, e, {
                value: Oe
              }),
              group: r({}, e, {
                value: Pe
              }),
              groupCollapsed: r({}, e, {
                value: Te
              }),
              groupEnd: r({}, e, {
                value: Se
              })
            });
          }
          J < 0 && T("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
        }
      }
      var ue = M.ReactCurrentDispatcher, ce;
      function Q(e, o, s) {
        {
          if (ce === void 0)
            try {
              throw Error();
            } catch (w) {
              var f = w.stack.trim().match(/\n( *(at )?)/);
              ce = f && f[1] || "";
            }
          return `
` + ce + e;
        }
      }
      var le = !1, ee;
      {
        var tt = typeof WeakMap == "function" ? WeakMap : Map;
        ee = new tt();
      }
      function je(e, o) {
        if (!e || le)
          return "";
        {
          var s = ee.get(e);
          if (s !== void 0)
            return s;
        }
        var f;
        le = !0;
        var w = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var C;
        C = ue.current, ue.current = null, Qe();
        try {
          if (o) {
            var x = function() {
              throw Error();
            };
            if (Object.defineProperty(x.prototype, "props", {
              set: function() {
                throw Error();
              }
            }), typeof Reflect == "object" && Reflect.construct) {
              try {
                Reflect.construct(x, []);
              } catch ($) {
                f = $;
              }
              Reflect.construct(e, [], x);
            } else {
              try {
                x.call();
              } catch ($) {
                f = $;
              }
              e.call(x.prototype);
            }
          } else {
            try {
              throw Error();
            } catch ($) {
              f = $;
            }
            e();
          }
        } catch ($) {
          if ($ && f && typeof $.stack == "string") {
            for (var g = $.stack.split(`
`), k = f.stack.split(`
`), y = g.length - 1, b = k.length - 1; y >= 1 && b >= 0 && g[y] !== k[b]; )
              b--;
            for (; y >= 1 && b >= 0; y--, b--)
              if (g[y] !== k[b]) {
                if (y !== 1 || b !== 1)
                  do
                    if (y--, b--, b < 0 || g[y] !== k[b]) {
                      var V = `
` + g[y].replace(" at new ", " at ");
                      return typeof e == "function" && ee.set(e, V), V;
                    }
                  while (y >= 1 && b >= 0);
                break;
              }
          }
        } finally {
          le = !1, ue.current = C, et(), Error.prepareStackTrace = w;
        }
        var F = e ? e.displayName || e.name : "", Ue = F ? Q(F) : "";
        return typeof e == "function" && ee.set(e, Ue), Ue;
      }
      function Ae(e, o, s) {
        return je(e, !1);
      }
      function rt(e) {
        var o = e.prototype;
        return !!(o && o.isReactComponent);
      }
      function te(e, o, s) {
        if (e == null)
          return "";
        if (typeof e == "function")
          return je(e, rt(e));
        if (typeof e == "string")
          return Q(e);
        switch (e) {
          case l:
            return Q("Suspense");
          case R:
            return Q("SuspenseList");
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case p:
              return Ae(e.render);
            case h:
              return te(e.type, o, s);
            case m:
              return Ae(e._render);
            case _: {
              var f = e, w = f._payload, C = f._init;
              try {
                return te(C(w), o, s);
              } catch {
              }
            }
          }
        return "";
      }
      var De = {}, Ne = M.ReactDebugCurrentFrame;
      function re(e) {
        if (e) {
          var o = e._owner, s = te(e.type, e._source, o ? o.type : null);
          Ne.setExtraStackFrame(s);
        } else
          Ne.setExtraStackFrame(null);
      }
      function nt(e, o, s, f, w) {
        {
          var C = Function.call.bind(Object.prototype.hasOwnProperty);
          for (var x in e)
            if (C(e, x)) {
              var g = void 0;
              try {
                if (typeof e[x] != "function") {
                  var k = Error((f || "React class") + ": " + s + " type `" + x + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof e[x] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  throw k.name = "Invariant Violation", k;
                }
                g = e[x](o, x, f, s, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (y) {
                g = y;
              }
              g && !(g instanceof Error) && (re(w), T("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", f || "React class", s, x, typeof g), re(null)), g instanceof Error && !(g.message in De) && (De[g.message] = !0, re(w), T("Failed %s type: %s", s, g.message), re(null));
            }
        }
      }
      var z = M.ReactCurrentOwner, fe = Object.prototype.hasOwnProperty, at = {
        key: !0,
        ref: !0,
        __self: !0,
        __source: !0
      }, Ie, Me, de;
      de = {};
      function ot(e) {
        if (fe.call(e, "ref")) {
          var o = Object.getOwnPropertyDescriptor(e, "ref").get;
          if (o && o.isReactWarning)
            return !1;
        }
        return e.ref !== void 0;
      }
      function it(e) {
        if (fe.call(e, "key")) {
          var o = Object.getOwnPropertyDescriptor(e, "key").get;
          if (o && o.isReactWarning)
            return !1;
        }
        return e.key !== void 0;
      }
      function st(e, o) {
        if (typeof e.ref == "string" && z.current && o && z.current.stateNode !== o) {
          var s = I(z.current.type);
          de[s] || (T('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', I(z.current.type), e.ref), de[s] = !0);
        }
      }
      function ut(e, o) {
        {
          var s = function() {
            Ie || (Ie = !0, T("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
          };
          s.isReactWarning = !0, Object.defineProperty(e, "key", {
            get: s,
            configurable: !0
          });
        }
      }
      function ct(e, o) {
        {
          var s = function() {
            Me || (Me = !0, T("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
          };
          s.isReactWarning = !0, Object.defineProperty(e, "ref", {
            get: s,
            configurable: !0
          });
        }
      }
      var lt = function(e, o, s, f, w, C, x) {
        var g = {
          $$typeof: n,
          type: e,
          key: o,
          ref: s,
          props: x,
          _owner: C
        };
        return g._store = {}, Object.defineProperty(g._store, "validated", {
          configurable: !1,
          enumerable: !1,
          writable: !0,
          value: !1
        }), Object.defineProperty(g, "_self", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: f
        }), Object.defineProperty(g, "_source", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: w
        }), Object.freeze && (Object.freeze(g.props), Object.freeze(g)), g;
      };
      function ft(e, o, s, f, w) {
        {
          var C, x = {}, g = null, k = null;
          s !== void 0 && (g = "" + s), it(o) && (g = "" + o.key), ot(o) && (k = o.ref, st(o, w));
          for (C in o)
            fe.call(o, C) && !at.hasOwnProperty(C) && (x[C] = o[C]);
          if (e && e.defaultProps) {
            var y = e.defaultProps;
            for (C in y)
              x[C] === void 0 && (x[C] = y[C]);
          }
          if (g || k) {
            var b = typeof e == "function" ? e.displayName || e.name || "Unknown" : e;
            g && ut(x, b), k && ct(x, b);
          }
          return lt(e, g, k, w, f, z.current, x);
        }
      }
      var pe = M.ReactCurrentOwner, Ve = M.ReactDebugCurrentFrame;
      function U(e) {
        if (e) {
          var o = e._owner, s = te(e.type, e._source, o ? o.type : null);
          Ve.setExtraStackFrame(s);
        } else
          Ve.setExtraStackFrame(null);
      }
      var ve;
      ve = !1;
      function ge(e) {
        return typeof e == "object" && e !== null && e.$$typeof === n;
      }
      function $e() {
        {
          if (pe.current) {
            var e = I(pe.current.type);
            if (e)
              return `

Check the render method of \`` + e + "`.";
          }
          return "";
        }
      }
      function dt(e) {
        {
          if (e !== void 0) {
            var o = e.fileName.replace(/^.*[\\\/]/, ""), s = e.lineNumber;
            return `

Check your code at ` + o + ":" + s + ".";
          }
          return "";
        }
      }
      var Le = {};
      function pt(e) {
        {
          var o = $e();
          if (!o) {
            var s = typeof e == "string" ? e : e.displayName || e.name;
            s && (o = `

Check the top-level render call using <` + s + ">.");
          }
          return o;
        }
      }
      function We(e, o) {
        {
          if (!e._store || e._store.validated || e.key != null)
            return;
          e._store.validated = !0;
          var s = pt(o);
          if (Le[s])
            return;
          Le[s] = !0;
          var f = "";
          e && e._owner && e._owner !== pe.current && (f = " It was passed a child from " + I(e._owner.type) + "."), U(e), T('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', s, f), U(null);
        }
      }
      function Ye(e, o) {
        {
          if (typeof e != "object")
            return;
          if (Array.isArray(e))
            for (var s = 0; s < e.length; s++) {
              var f = e[s];
              ge(f) && We(f, o);
            }
          else if (ge(e))
            e._store && (e._store.validated = !0);
          else if (e) {
            var w = B(e);
            if (typeof w == "function" && w !== e.entries)
              for (var C = w.call(e), x; !(x = C.next()).done; )
                ge(x.value) && We(x.value, o);
          }
        }
      }
      function vt(e) {
        {
          var o = e.type;
          if (o == null || typeof o == "string")
            return;
          var s;
          if (typeof o == "function")
            s = o.propTypes;
          else if (typeof o == "object" && (o.$$typeof === p || o.$$typeof === h))
            s = o.propTypes;
          else
            return;
          if (s) {
            var f = I(o);
            nt(s, e.props, "prop", f, e);
          } else if (o.PropTypes !== void 0 && !ve) {
            ve = !0;
            var w = I(o);
            T("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", w || "Unknown");
          }
          typeof o.getDefaultProps == "function" && !o.getDefaultProps.isReactClassApproved && T("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
        }
      }
      function gt(e) {
        {
          for (var o = Object.keys(e.props), s = 0; s < o.length; s++) {
            var f = o[s];
            if (f !== "children" && f !== "key") {
              U(e), T("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", f), U(null);
              break;
            }
          }
          e.ref !== null && (U(e), T("Invalid attribute `ref` supplied to `React.Fragment`."), U(null));
        }
      }
      function Be(e, o, s, f, w, C) {
        {
          var x = Xe(e);
          if (!x) {
            var g = "";
            (e === void 0 || typeof e == "object" && e !== null && Object.keys(e).length === 0) && (g += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
            var k = dt(w);
            k ? g += k : g += $e();
            var y;
            e === null ? y = "null" : Array.isArray(e) ? y = "array" : e !== void 0 && e.$$typeof === n ? (y = "<" + (I(e.type) || "Unknown") + " />", g = " Did you accidentally export a JSX literal instead of a component?") : y = typeof e, T("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", y, g);
          }
          var b = ft(e, o, s, w, C);
          if (b == null)
            return b;
          if (x) {
            var V = o.children;
            if (V !== void 0)
              if (f)
                if (Array.isArray(V)) {
                  for (var F = 0; F < V.length; F++)
                    Ye(V[F], e);
                  Object.freeze && Object.freeze(V);
                } else
                  T("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
              else
                Ye(V, e);
          }
          return e === a.Fragment ? gt(b) : vt(b), b;
        }
      }
      function ht(e, o, s) {
        return Be(e, o, s, !0);
      }
      function Et(e, o, s) {
        return Be(e, o, s, !1);
      }
      var xt = Et, _t = ht;
      a.jsx = xt, a.jsxs = _t;
    }();
  }(Ee)), Ee;
}
(function(a) {
  process.env.NODE_ENV === "production" ? a.exports = Mt() : a.exports = Vt();
})(we);
const W = we.exports.jsx, $t = we.exports.jsxs, Lt = mt(({
  id: a,
  value: t
}, r) => {
  const {
    dispatch: n,
    props: {
      readOnly: i,
      spanStyle: c,
      spanClassName: v
    }
  } = se(), u = ae(null);
  typeof r == "function" && r(u);
  const d = It(u);
  return /* @__PURE__ */ W("span", {
    ref: u,
    style: c,
    className: v,
    contentEditable: !i,
    suppressContentEditableWarning: !0,
    onInput: (l) => {
      var h;
      d();
      const R = (h = l.currentTarget.textContent) != null ? h : "";
      n(Y.Change, {
        key: a,
        value: R
      });
    },
    onPaste: Wt,
    children: t
  });
});
function Wt(a) {
  a.preventDefault();
  const t = a.clipboardData.getData("text");
  document.execCommand("insertText", !1, t);
}
const Yt = (a, t) => {
  const r = ae(null);
  return yt(() => {
    var n;
    if (r.current) {
      let i = (n = t.current.get(r.current)) == null ? void 0 : n.current;
      i.focus();
      let c = a.getPosition();
      c && i && G.setIndex(i, c), r.current = null;
    }
  }), r;
}, Bt = (a, t) => {
  const r = Nt(), n = {
    current: /* @__PURE__ */ new Map()
  }, {
    dispatch: i,
    sliceMap: c
  } = se(), v = [...c.keys()], u = ae(null), d = Yt(r, n), p = (_) => {
    var M, T;
    const m = _.target, A = G.getCaretIndex(m), O = A === 0, D = A === ((M = m.textContent) == null ? void 0 : M.length), P = {
      [K.LEFT]: O ? E : null,
      [K.RIGHT]: D ? S : null,
      [K.UP]: null,
      [K.DOWN]: null,
      [K.DELETE]: D ? B : null,
      [K.BACKSPACE]: O ? j : null
    };
    (T = P[_.key]) == null || T.call(P);
    function E() {
      if (u.current && u.current !== 0) {
        let N = h()[u.current - 1].current;
        N == null || N.focus(), G.setCaretToEnd(N);
      }
      _.preventDefault();
    }
    function S() {
      var N;
      u.current !== null && u.current !== [...n.current.values()].length - 1 && ((N = h()[u.current + 1].current) == null || N.focus()), _.preventDefault();
    }
    function j() {
      if (u.current && u.current > 0) {
        d.current = l();
        let N = [...n.current.keys()][u.current], H = v.indexOf(N);
        i(Y.Delete, {
          key: v[H - 1]
        });
      }
    }
    function B() {
      if (u.current !== null && u.current !== [...n.current.values()].length - 1) {
        d.current = R();
        let N = [...n.current.keys()][u.current], H = v.indexOf(N);
        i(Y.Delete, {
          key: v[H + 1]
        });
      }
    }
  };
  function l() {
    var P, E, S, j;
    if (u.current === null)
      return null;
    let _ = [...n.current.keys()][u.current - 1], m = [...n.current.keys()][u.current], A = (E = (P = n.current.get(_)) == null ? void 0 : P.current) == null ? void 0 : E.textContent, O = (j = (S = n.current.get(m)) == null ? void 0 : S.current) == null ? void 0 : j.textContent, D = A + O;
    return r.setPosition(A.length), ne(D);
  }
  function R() {
    var P, E, S, j;
    if (u.current === null)
      return null;
    let _ = [...n.current.keys()][u.current + 1], m = [...n.current.keys()][u.current], A = (E = (P = n.current.get(_)) == null ? void 0 : P.current) == null ? void 0 : E.textContent, O = (j = (S = n.current.get(m)) == null ? void 0 : S.current) == null ? void 0 : j.textContent, D = O + A;
    return r.setPosition(O.length), ne(D);
  }
  function h() {
    return [...n.current.values()];
  }
  return {
    register: (_) => (m) => n.current.set(_, m),
    onFocus: (_) => {
      document.addEventListener("selectionchange", a), u.current = [...n.current.values()].findIndex((m) => m.current === _.target);
    },
    onBlur: () => {
      document == null || document.removeEventListener("selectionchange", a), setTimeout((_) => t(), 200), u.current = null;
    },
    onKeyDown: p
  };
}, Ut = () => {
  const {
    sliceMap: a,
    options: t,
    props: {
      Mark: r,
      ...n
    },
    trigger: {
      check: i,
      clear: c
    }
  } = se(), {
    register: v,
    ...u
  } = Bt(i, c), d = n.className ? Fe + " " + n.className : Fe;
  return /* @__PURE__ */ W("div", {
    className: d,
    style: n.style,
    ...u,
    children: [...a].map(([p, l]) => ie(l) ? /* @__PURE__ */ W(r, {
      tabIndex: -1,
      ...t[l.childIndex].initializer(l.value, l.id)
    }, p) : /* @__PURE__ */ W(Lt, {
      ref: v(p),
      id: p,
      value: l
    }, p))
  });
};
const Ft = (a) => Z(() => jt(a), [a]), Kt = ({ value: a, onChange: t }, r) => {
  const n = Z(oe.split(a, r), [a]), i = Z(v, [n.length]), c = u();
  return [i, c];
  function v() {
    return n.reduce((p, l) => p.set(d(l, p), l), /* @__PURE__ */ new Map());
    function d(p, l) {
      let R = ie(p) ? p.id + p.value : p, h = 0, _ = ne(R, h);
      for (; l.has(_); )
        _ = ne(R, h++);
      return _;
    }
  }
  function u() {
    return xe((d, p) => {
      l(i, { type: d, payload: p });
      function l(R, h) {
        switch (h.type) {
          case Y.Change:
            const { key: _, value: m = "" } = h.payload;
            R.set(_, m), t(Ke([...R.values()], r));
            break;
          case Y.Delete:
            R.delete(h.payload.key), t(Ke([...R.values()], r));
            break;
          default:
            throw new Error();
        }
      }
    }, [i]);
  }
}, qt = (a) => {
  const [t, r] = Je(), n = xe(() => r(void 0), []), i = xe(() => {
    var c;
    for (let v of a) {
      let {
        word: u,
        triggeredValue: d,
        text: p,
        indexBefore: l
      } = (c = Gt(v.trigger)) != null ? c : {};
      if (u !== void 0) {
        r({
          word: u,
          triggeredValue: d,
          style: Ht(),
          option: v,
          text: p,
          indexBefore: l
        });
        return;
      }
    }
    r(void 0);
  }, []);
  return Pt({}, t, {
    check: i,
    clear: n
  });
};
function Gt(a) {
  var E, S, j, B;
  if (!a)
    return;
  const t = window.getSelection(), r = t == null ? void 0 : t.anchorOffset, n = (E = t == null ? void 0 : t.anchorNode) == null ? void 0 : E.textContent;
  if (!r || !n)
    return;
  const i = n.slice(0, r), c = n.slice(r), u = X(a) + "\\w*$", d = new RegExp(u), p = new RegExp(/^\w*/), l = i.match(d), R = l == null ? void 0 : l.index, h = (S = l == null ? void 0 : l[0]) != null ? S : "", _ = (B = (j = c.match(p)) == null ? void 0 : j[0]) != null ? B : "", m = h + _, O = St(a).exec(m), D = O == null ? void 0 : O[0], P = O == null ? void 0 : O[1];
  if (P !== void 0)
    return {
      word: P,
      triggeredValue: D,
      text: n,
      indexBefore: R
    };
}
function Ht() {
  var t;
  const a = (t = window.getSelection()) == null ? void 0 : t.getRangeAt(0).getBoundingClientRect();
  return a ? {
    left: a.left,
    top: a.top + 20
  } : {
    left: 0,
    top: 0
  };
}
const Jt = (a) => {
  const t = Ft(a.children), [r, n] = Kt(a, t), i = qt(t);
  return {
    options: t,
    props: a,
    sliceMap: r,
    dispatch: n,
    trigger: i
  };
}, zt = ({
  data: a,
  word: t,
  style: r,
  onSelect: n,
  ...i
}) => {
  const [c, v] = Je(NaN), u = Z(() => a.filter((d) => d.toLowerCase().indexOf(t.toLowerCase()) > -1), [t]);
  return u.length ? /* @__PURE__ */ W("ul", {
    className: "mk-suggestions",
    style: r,
    children: u.map((d, p) => {
      let l;
      return p === c && (l = "mk-suggestion-active"), /* @__PURE__ */ W("li", {
        className: l,
        onClick: (R) => n({
          id: p.toString(),
          value: d
        }),
        children: d
      }, d);
    })
  }) : null;
}, Xt = () => {
  var h, _, m;
  const {
    sliceMap: a,
    trigger: {
      word: t,
      option: r,
      style: n,
      text: i,
      indexBefore: c,
      triggeredValue: v
    },
    dispatch: u,
    props: {
      Overlay: d = zt
    }
  } = se();
  if (t === void 0)
    return null;
  const l = {
    word: t,
    style: n,
    onSelect: ({
      id: A,
      value: O
    }) => {
      const D = Re(r.markup, O, A);
      let P;
      for (let [S, j] of a.entries())
        if (j === i) {
          P = S;
          break;
        }
      let E = (i == null ? void 0 : i.slice(0, c)) + D + (i == null ? void 0 : i.slice(c + v.length));
      P && u(Y.Change, {
        value: E,
        key: P
      });
    },
    data: (h = r.data) != null ? h : []
  }, R = (m = (_ = r.initOverlay) == null ? void 0 : _.call(r, l)) != null ? m : l;
  return bt(d, R);
}, er = (a) => {
  const t = Jt(a);
  return /* @__PURE__ */ $t(Dt, {
    value: t,
    children: [/* @__PURE__ */ W(Ut, {}), /* @__PURE__ */ W(Xt, {})]
  });
}, tr = (a) => null;
function styleInject(css,ref){if(ref===void 0){ref={}}var insertAt=ref.insertAt;if(!css||typeof document==="undefined"){return}var head=document.head||document.getElementsByTagName("head")[0];var style=document.createElement("style");style.type="text/css";if(insertAt==="top"){if(head.firstChild){head.insertBefore(style,head.firstChild)}else{head.appendChild(style)}}else{head.appendChild(style)}if(style.styleSheet){style.styleSheet.cssText=css}else{style.appendChild(document.createTextNode(css))}};styleInject(`.mk-input {
}
.mk-input span {
    outline: none;
    white-space: pre-wrap;
}

.mk-suggestions {
    border: 1px solid #ccc;
    max-height: 186px;
    overflow-y: auto;
    padding-left: 0;
    position: absolute;
    background: white;
    width: fit-content;
    min-width: 100px;

    transition: 1.1s ease-out;
    filter: blur(0);
    transform: scale(1);
    opacity: 1;
    visibility: visible;

    color: #000;
    border-radius: 4%;
    box-shadow: 0 3px 6px -2px rgba(0, 0, 0, 0.6);
}

.mk-suggestions li {
    padding: 0.5rem;
}

.mk-suggestions li:hover,
.mk-suggestion-active {
    background-color: #cce9ff;
    color: #2589f5;
    cursor: pointer;
}
`);
export {
  er as MarkedInput,
  tr as Option,
  Re as annotate,
  Qt as denote
};
